libstdc++: __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc > Struct Template Reference

libstdc++

__gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc > Struct Template Referenceabstract

`#include <branch_policy.hpp>`

Inheritance diagram for __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >:
[legend]

## Protected Types
typedef rebind_v::const_pointer | const_pointer
typedef rebind_v::const_reference | const_reference
typedef Node_Itr::value_type | it_type
typedef rebind_k::const_reference | key_const_reference
typedef value_type::first_type | key_type
typedef remove_const< key_type >::type | rckey_type
typedef remove_const< value_type >::type | rcvalue_type
typedef rebind_traits< _Alloc, rckey_type > | rebind_k
typedef rebind_traits< _Alloc, rcvalue_type > | rebind_v
typedef rebind_v::reference | reference
typedef std::iterator_traits< it_type >::value_type | value_type

## Protected Member Functions
virtual it_type | end ()=0
it_type | end_iterator () const

## Static Protected Member Functions
static key_const_reference | extract_key (const_reference r_val)

## Detailed Description

template<typename Node_CItr, typename Node_Itr, typename _Alloc>
struct __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >

Primary template, base class for branch structure policies.

Definition at line 53 of file branch_policy.hpp.

## Member Typedef Documentation

## ◆ const_pointer

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef rebind_v::const_pointer __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::const_pointer
| protected

Definition at line 68 of file branch_policy.hpp.

## ◆ const_reference

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef rebind_v::const_reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::const_reference
| protected

Definition at line 67 of file branch_policy.hpp.

## ◆ it_type

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef Node_Itr::value_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::it_type
| protected

Definition at line 56 of file branch_policy.hpp.

## ◆ key_const_reference

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef rebind_k::const_reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::key_const_reference
| protected

Definition at line 70 of file branch_policy.hpp.

## ◆ key_type

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef value_type::first_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::key_type
| protected

Definition at line 58 of file branch_policy.hpp.

## ◆ rckey_type

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef remove_const<key_type>::type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rckey_type
| protected

Definition at line 61 of file branch_policy.hpp.

## ◆ rcvalue_type

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef remove_const<value_type>::type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rcvalue_type
| protected

Definition at line 60 of file branch_policy.hpp.

## ◆ rebind_k

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef rebind_traits<_Alloc, rckey_type> __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rebind_k
| protected

Definition at line 64 of file branch_policy.hpp.

## ◆ rebind_v

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef rebind_traits<_Alloc, rcvalue_type> __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rebind_v
| protected

Definition at line 63 of file branch_policy.hpp.

## ◆ reference

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef rebind_v::reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::reference
| protected

Definition at line 66 of file branch_policy.hpp.

## ◆ value_type

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

typedef std::iterator_traits<it_type>::value_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::value_type
| protected

Definition at line 57 of file branch_policy.hpp.

## Constructor & Destructor Documentation

## ◆ ~branch_policy()

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

virtual __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::~branch_policy | ( |  | ) |
| inline protected virtual

Definition at line 84 of file branch_policy.hpp.

## Member Function Documentation

## ◆ end_iterator()

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

it_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::end_iterator | ( |  | ) | const
| inline protected

Definition at line 80 of file branch_policy.hpp.

## ◆ extract_key()

template<typename Node_CItr, typename Node_Itr, typename _Alloc>

key_const_reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::extract_key | ( | const_reference | r_val | ) |
| inline static protected

Definition at line 73 of file branch_policy.hpp.

The documentation for this struct was generated from the following file:

- branch_policy.hpp